#ifndef _INF_MAIN_H
#define _INF_MAIN_H

#include <libvisual/libvisual.h>

#define FALSE 0
#define TRUE 1

#define NB_PALETTES 5

struct infinite_col {
	unsigned char r;
	unsigned char g;
	unsigned char b;
};

typedef struct t_coord {
	int x,y;
} t_coord;

typedef struct t_complex {
	float x,y;
} t_complex;

typedef struct t_interpol {
	unsigned int coord ;  //coordinates of the top left pixel.
	unsigned int weight; //32 bits = 4*8= weights of the four corners
} t_interpol;

typedef struct t_effect {
	int num_effect;
	int x_curve;
	int curve_color;
	int curve_amplitude;
	int spectral_amplitude;
	int spectral_color;
	int mode_spectre;
	int spectral_shift;
} t_effect;

typedef struct {
	short pcm_data[2][512];
	int plugwidth;
	int plugheight;
	VisPalette pal;

	unsigned char *surface1;
	unsigned char *surface2;

	int teff;
	int tcol;

	struct infinite_col color_table[NB_PALETTES][256];

	int old_color;
	int color;
	int t_last_color;
	int t_last_effect;

	t_effect current_effect;
	t_interpol *vector_field;
} InfinitePrivate;

#endif /* _INF_MAIN_H */
